<?php
// $Id: luceneapi_facet.hooks.inc,v 1.1.2.3 2009/07/23 02:27:54 cpliakas Exp $

/**
 * @file
 * Example file that defines the Search Lucene Facets hooks.
 *
 * @ingroup luceneapi
 */

/**
 * Invoked by modules that define facets for Search Lucene API modules.
 *
 * @param $op
 *   A string containing the operation being performed.
 * @param $module
 *   A string containing the module handling the search.
 * @param $type
 *   A string containing the type of content $module indexes, NULL if no type.
 * @return
 *   Varies dependent on $op:
 *     - name: An array of facet names or a string containing a facet name.
 *     - facet: An array of form elements building the facets.
 *     - callback: An array of callbacks keyed by function name to parameters.
 */
function hook_luceneapi_facet($op, $module, $type = NULL) {
}

/**
 * Defines a facet realm.  Realms are groups of facets that are displayed in
 * similar fassion on some part of the search page, for exampe a fieldset or
 * a block.
 *
 * @return
 *   An array of realm definitions.
 */
function hook_luceneapi_facet_realm() {
}

/**
 * Provides access to the facets before they are rendered.
 *
 * @param &$facets
 *   An array containing the facet arrays.
 * @param $realm
 *   A string containing the realm.
 * @param $module
 *   A string containing the module handling the search.
 * @param $type
 *   A string containing the type of content $module indexes, NULL if no type.
 * @return
 *   NULL
 */
function hook_luceneapi_facet_alter(&$facets, $realm, $module, $type = NULL) {
}

/**
 * Provides access to the items after they are rendered.
 *
 * @param &$items
 *   An array containing the processed items, usually a FAPI array.
 * @param $realm
 *   A string containing the realm.
 * @param $module
 *   A string containing the module handling the search.
 * @param $type
 *   A string containing the type of content $module indexes, NULL if no type.
 * @return
 *   NULL
 */
function hook_luceneapi_facet_postrender_alter(&$items, $realm, $module, $type = NULL) {
}
